EXE = exercise_04_18
C_FLAGS = -Wall -Wextra -Werror -g3

dbg: debug/$(EXE)

debug/$(EXE): debug/main.o
	g++    $(C_FLAGS) $^ -o $@

debug/main.o: debug/main.s
	g++ -c $(C_FLAGS) $^ -o $@

debug/main.s: debug/main.ii
	g++ -S $(C_FLAGS) $^ -o $@

debug/main.ii: main.cpp
	g++ -E $(C_FLAGS) $^ -o $@

debug/main.ii: | debug

debug:
	mkdir -p debug

clean:
	rm -rf debug *.ii *.s *.o *.out

test: debug/$(EXE)
	@./debug/$(EXE) > test1.out || echo "Test 1 is executing..."
	@diff test1.out test1.expected && echo "\n\tTEST 1 PASSED ☑ \n" || echo "\n\tTEST 1 FAILED ☒ \n"

.PRECIOUS: main.ii main.s
.SECONDARY: main.ii main.s

